;
;	Pequeno "Invader" para
; 	experimentar o 68000
;

	jsr	inicializa
	jsr	getrandom
	jsr	ligajoystick

;	jsr	printimagem

	move.l	$70,old_vbl		; backup $70
	move.l	#mainloop,$70
	
;	Espera que se carregue em Escape
keyloop
	cmp.b #$01,$fffc02
	bne.s keyloop

	move.l	old_vbl,$70

	jsr desligajoystick

	jsr IKBD_Flush
	jsr IKBD_FlushGemdos

	jsr restaura

   
; clean exit
	clr.w	-(a7)
	trap	#1


; Loop Principal
mainloop

	movem.l	d0-d7/a0-a6,-(a7)	; Backup os Registos

	jsr apagasprites			; Apaga Todos os Sprites
	jsr	moveinimigo				; Move os Inimigos
	jsr	movenave				; Move a Nave
	
	tst.w	tiro				; Existe Tiro?
	beq.s	mlverexplo			; Se não Verifica se há Explosão
	jsr		movetiro			; Se sim Move o Tiro
	jsr		vercolisao1			; Se sim Verifica a Colisão entro o Tiro e o Inimigo

mlverexplo
	tst.w	explo				; Existe Explosão?
	beq.s	mainloop2			; Se não Imprime os Sprites
	jsr		moveexplosao		; Se sim Move a Explosão
	
mainloop2
	jsr imprimesprites			; Imprime todos os Sprites
	
;	move.w	#$7FFF,d0
;llll
;	dbf d0,llll

	movem.l (a7)+,d0-d7/a0-a6	; Restaura os Registos

	rte
	

; Inicializa o Programa
inicializa

;	Supervisor mode
	clr.l	-(a7)         
	move.w	#32,-(a7)      
	trap	#1         
	addq.l	#6,a7         
	move.l	d0,old_stack
      
;	Guarda a Palette Antiga
	move.l	#old_palette,a0      
	movem.l	$ffff8240,d0-d7      
	movem.l	d0-d7,(a0)

; 	Guarda a Resolução Antiga
	move.w	$FF8260,old_resolution 
	
; 	Guarda o Endereço de Écran Antigo
	move.l	$44e,old_screen

; 	Muda para a Nova Resolução : 320*200*16
	move.w	#00,$FF8260
	
;	Coloca a Palette Nova
	movem.l	pic1+2,d0-d7
	movem.l	d0-d7,$ff8240
	
;	Coloca o Endereço de Écran Novo
	move.l	#screen_buf,d0		; put screen_buf address in d0
	add.l	#$ff,d0
	clr.b	d0              	; put on 256 byte boundary  
	move.l	d0,new_screen
	
    lsr.w	#8,d0
	move.l	d0,$ff8200     		; put in mid screen address byte
	
	rts

; Restaura as Definições Originais	
restaura

;	Restaura a Resolução Antiga
	move.w	old_resolution,$FF8260
	
;	Restaura a Palette Antiga
	move.l	#old_palette,a0      
	movem.l	(a0),d0-d7      
	movem.l	d0-d7,$ffff8240

;	Restaura o Endereço de Écran Antigo	
	move.l	old_screen,d0		; put screen_buf address in d0
	add.l	#$ff,d0
	clr.b	d0          		; put on 256 byte boundary  
	lsr.w	#8,d0
	move.l	d0,$ff8200     		; put in mid screen address byte

;	User mode
	move.l	old_stack,-(a7)      
	move.w	#32,-(a7)      
	trap	#1         
	addq.l	#6,a7         

	rts

; Gera um Número Aleatório
getrandom

	move.w	#17,-(a7)
	trap	#14
	addq.l	#2,a7			; Gera um Número Aleatório
	and.l	#%11111111,d0	; make it maximum 255
	cmp.l	#160,d0			; Faz Loop até ser menor que 160
	bgt.s	getrandom
	move.w	d0,iniy
;	move.w	#140,iniy
	
	rts

;	Imprime a Imagem no Écran
printimagem	

	move.l	new_screen,a0		; vai buscar o Novo Endereço da Memória do Écran

	move.l	#pic1+34,a1    		; a1 points to picture
	move.l	#7999,d0			; 320*200 / 8 - 1
;	move.l	#1,d0				; 320*200 / 8 - 1
primg_loop
	move.l	(a1)+,(a0)+			; move one longword to screen
	dbf		d0,primg_loop
	
	rts
	
; Imprime um Sprite no Écran	
printsprite	

	move.w	ospry,d0			; Calcula a Posição do Sprite na Imagem que contém os Sprites
	mulu.w	#320,d0
	add.w	osprx,d0
	divu.w	#2,d0
	move.l	d0,sproff
	
	move.w	spry,d0				; Calcula a Posição do Écran onde o Sprite vai ser Impresso
	mulu.w	#320,d0
	add.w	sprx,d0
	divu.w	#2,d0
	move.l	d0,prsproff

	move.l	new_screen,a0		; vai buscar o Novo Endereço da Memória do Écran
	add.l	prsproff,a0			; adiciona o Offset do Écran onde o Sprite vai ser Impresso

	move.l	#pic1+34,a1    		; vai buscar o Endereço da Imagem que contém os Sprites
	add.l	sproff,a1			; adiciona o Offset da posição onde está o Sprite

	move.w	sprtx,d0			; Calcula o Número de LongWords do Sprite a serem copiadas
	add.w	#16,d0
	divu.w	#16,d0
	subq	#1,d0
	move.w d0,numlw
	
	move.w	sprtx,d0			; Calcula o Número de Bytes a serem Saltados para a linha seguinte
	add.w	#16,d0
	divu.w	#2,d0
	move.l	d0,numlw2
	move.w	#160,d0
	sub.l	numlw2,d0
	move.l	d0,numlw2
	
	move.w	sprty,d0			; Número de Linhas do Sprite
	subq	#1,d0
prspr_loop
	move numlw,d1
prspr_loop2
	move.l	(a1)+,(a0)+			; 1 - Long Word : 2 - Words : 4 - Bytes
	move.l	(a1)+,(a0)+			; 1 - Long Word : 2 - Words : 4 - Bytes
	dbf		d1,prspr_loop2
	add.l  	numlw2,a1
	add.l   numlw2,a0
	dbf		d0,prspr_loop
	
	rts
	
; Apaga um Sprite do Écran	
delsprite	

	move.w	spry,d0				; Calcula a Posição do Écran onde o Sprite vai ser Impresso
	mulu.w	#320,d0
	add.w	sprx,d0
	divu.w	#2,d0
	move.l	d0,prsproff

	move.l	new_screen,a0		; vai buscar o Novo Endereço da Memória do Écran
	add.l	prsproff,a0			; adiciona o Offset do Écran onde o Sprite vai ser Impresso

	move.w	sprtx,d0			; Calcula o Número de LongWords do Sprite a serem copiadas
	add.w	#16,d0
	divu.w	#16,d0
	subq	#1,d0
	move.w d0,numlw
	
	move.w	sprtx,d0			; Calcula o Número de Bytes a serem Saltados para a linha seguinte
	add.w	#16,d0
	divu.w	#2,d0
	move.l	d0,numlw2
	move.w	#160,d0
	sub.l	numlw2,d0
	move.l	d0,numlw2
	
	move.w	sprty,d0			; Número de Linhas do Sprite
	subq	#1,d0
dlspr_loop
	move numlw,d1
dlspr_loop2
	move.l	#0,(a0)+			; 1 - Long Word : 2 - Words : 4 - Bytes
	move.l	#0,(a0)+			; 1 - Long Word : 2 - Words : 4 - Bytes
	dbf		d1,dlspr_loop2
	add.l  	numlw2,a1
	add.l   numlw2,a0
	dbf		d0,dlspr_loop
	
	rts

; Limpa o Teclado
IKBD_Flush

	move.l	d0,-(a7)				; Guarda o Registo no Stack

flush
	btst	#0,$fffffc00.w			; kbd data waiting?
	beq.s	empty1					; no, buffer empty
	move.b	$fffffc02.w,d0			; read data
	bra.s	flush					; check for more data

empty1
	move.l	(a7)+,d0				; Restora o Registo do Stack
	
	rts

; Limpa buffer do Teclado	
IKBD_FlushGemdos

	movem.l	d0-d2/a0-a2,-(a7)	; Backup os Registos

loop2
	move.w	#$b,-(a7)			; Cconis()
	trap	#1					; call GEMDOS
	addq.l	#2,a7				; fix stack

	tst.w	d0					; characters waiting?
	beq		empty2				; no, empty

	move.w	#8,-(a7)			; Cnecin()
	trap	#1					; call GEMDOS
	addq.l	#2,a7				; fix stack
	bra.s	loop2				; loop until buffer empty

empty2
	movem.l	(a7)+,d0-d2/a0-a2	; Restora os Registos
	
	rts

; Ativa o Interrupt do Joystick
ligajoystick

	move.w	#34,-(a7)
	trap	#14
	addq.l	#2,a7				; return IKBD vector table

	move.l	d0,ikbd_vec			; store IKBD vectors address
	move.l	d0,a0				; a0 points to IKBD vectors
	move.l	24(a0),old_joy		; backup old joystick vector      
	move.l	#read_joy,24(a0)	; input my joystick vector

	move.l	#joy_on,-(a7)		; pointer to IKBD instructions
	move.w	#0,-(a7)			; instruction length - 1
	move.w	#25,-(a7)			; send instruction to IKBD
	trap	#14
	addq.l	#8,a7

	rts
	
; Desativa o Interrupt do Joystick
desligajoystick

	move.l	#mus_on,-(a7)		; pointer to IKBD instruction
	move.w	#0,-(a7)			; length of instruction - 1
	move.w	#25,-(a7)			; send instruction to IKBD
	trap	#14
	addq.l	#8,a7

	move.l	ikbd_vec,a0			; a0 points to old IKBD vectors
	move.l	old_joy,24(a0) 

	rts

; Lê o Joystick
read_joy

	; executes every time joystick information is changed
	move.b	1(a0),joy			; store joy 0 data
	move.b	2(a0),joy+1			; store joy 1 data
	
	rts

; Imprime os Sprites no Écran
imprimesprites

;	Imprime o Inimigo
;	Tamanho do Sprite a ser Impresso
	move.w	initx,sprtx
	move.w	inity,sprty
	
;	Posição onde o Sprite vai ser Impresso
	move.w	inix,sprx
	move.w	iniy,spry

;	Posição do Sprite na Imagem que contém os Sprites
	move.w	inipx,osprx
	move.w	inipy,ospry

;	Offset da Fase do Sprite
	move.w	inifase,d0
	move.w	initx,d1
	add.w	#16,d1
	mulu.w	d1,d0
	add.w	d0,osprx

	jsr printsprite
	
;	Imprime a Nave
;	Tamanho do Sprite a ser Impresso
	move.w	ntx,sprtx
	move.w	nty,sprty
	
;	Posição onde o Sprite vai ser Impresso
	move.w	nx,sprx
	move.w	ny,spry

;	Posição do Sprite na Imagem que contém os Sprites
	move.w	npx,osprx
	move.w	npy,ospry

;	Offset da Fase do Sprite	
	move.w	nfase,d0
	move.w	ntx,d1
	add.w	#16,d1
	mulu.w	d1,d0
	add.w	d0,osprx

	jsr printsprite
	
;	Imprime o Tiro
	tst.w	tiro		; Existe Tiro
	beq.s	isverexplo	; Se não então Verifica se há Explosão
	
;	Tamanho do Sprite a ser Impresso
	move.w	titx,sprtx
	move.w	tity,sprty
	
;	Posição onde o Sprite vai ser Impresso
	move.w	tix,sprx
	move.w	tiy,spry

;	Posição do Sprite na Imagem que contém os Sprites
	move.w	tipx,osprx
	move.w	tipy,ospry

;	Offset da Fase do Sprite	
	move.w	tifase,d0
	move.w	titx,d1
	add.w	#16,d1
	mulu.w	d1,d0
	add.w	d0,osprx

	jsr printsprite
	
isverexplo
;	Imprime a Explosão
	tst.w	explo				; Existe Explosão
	beq.w	saiimprimesprites	; Se não então sai da Rotina
	
;	Tamanho do Sprite a ser Impresso
	move.w	extx,sprtx
	move.w	exty,sprty
	
;	Posição onde o Sprite vai ser Impresso
	move.w	exx,sprx
	move.w	exy,spry

;	Posição do Sprite na Imagem que contém os Sprites
	move.w	expx,osprx
	move.w	expy,ospry

;	Offset da Fase do Sprite	
	move.w	exfase,d0
	move.w	extx,d1
	add.w	#16,d1
	mulu.w	d1,d0
	add.w	d0,osprx

	jsr printsprite

saiimprimesprites

	rts
	
; Apaga os Sprites no Écran
apagasprites

;	Apaga o Inimigo
;	Tamanho do Sprite a ser Impresso
	move.w	initx,sprtx
	move.w	inity,sprty
	
;	Posição onde o Sprite vai ser Impresso
	move.w	inix,sprx
	move.w	iniy,spry

	jsr delsprite

;	Apaga a Nave
;	Tamanho do Sprite a ser Impresso
	move.w	ntx,sprtx
	move.w	nty,sprty
	
;	Posição onde o Sprite vai ser Impresso
	move.w	nx,sprx
	move.w	ny,spry
	
	jsr delsprite

;	Apaga o Tiro
	tst.w	tiro		; Existe Tiro?
	beq.s	asverexplo	; Se não então Verifica se há Explosão
	
;	Tamanho do Sprite a ser Impresso
	move.w	titx,sprtx
	move.w	tity,sprty
	
;	Posição onde o Sprite vai ser Impresso
	move.w	tix,sprx
	move.w	tiy,spry

	jsr delsprite

asverexplo
;	Apaga a Explosão
	tst.w	explo			; Existe Explosão?
	beq.s saiapagasprites	; Se não então sai da Rotina
	
;	Tamanho do Sprite a ser Impresso
	move.w	extx,sprtx
	move.w	exty,sprty
	
;	Posição onde o Sprite vai ser Impresso
	move.w	exx,sprx
	move.w	exy,spry

	jsr delsprite

saiapagasprites

	rts
	
; Movimenta o Inimigo
moveinimigo

	cmp.w	#1,inidx		; Move-se Para a Esquerda?
	bne.s	movedireita		; Se não então move-se para a Direira
	
	tst.w	inix			; A Posição do Inimigo é a Zero?
	bne.s	moveesquerda	; Se não Decrementa a Posição
	
	tst.w	inifase			; A Fase é igual a Zero
	bne.w	decinifase		; Se não Decrementa a Fase
	eor.w	#1,inidx		; Se sim muda a Direção para a Direita
	bra.w	saimoveinimigo	; Sai da Rotina
	
decinifase
	subq.w	#4,inirx		; Decrementa a Posição Horizontal Real do Inimigo
	subq.w	#1,inifase		; Decrementa a Fase
	bra.w	saimoveinimigo	; Sai da Rotina

moveesquerda
	tst.w	inifase			; A Fase é Zero?
	beq.s	decmoveinimigo	; Se sim Decrementa a Posição
	subq.w	#4,inirx		; Se não Decrementa a Posição Horizontal Real do Inimigo
	subq.w	#1,inifase		; Decrementa a Fase
	bra.w	saimoveinimigo	; Sai da Rotina
	
decmoveinimigo
	move.w	initx,d0			; Decrementa a Posição de Acordo com o Tamanho do Inimigo
	sub.w	d0,inix
	move.w	inimfase,inifase	; Muda a Fase Para o Número Máximo de Fases (-1)
	bra.s	saimoveinimigo		; Sai da Rotina
	
movedireita
	move.w	#320-16,d0
	sub.w	initx,d0
	cmp.w	inix,d0			; A Posição é igual a 320 menos o Tamanho do Inimigo
	bne.s	movedireita2	; Se não Incrementa a Posição
	
	move.w	inimfase,d0
	cmp.w	inifase,d0		; A Fase é Igual ao Número Máximo de Fases
	bne.w	incinifase		; Se não Incrementa a Fase
	eor.w	#1,inidx		; Se sim muda a Direção para a Esquerda
	bra.s	saimoveinimigo	; Sai da Rotina
	
incinifase
	addq.w	#4,inirx		; Incrementa a Posição Horizontal Real do Inimigo
	addq.w	#1,inifase		; Incrementa a Fase
	bra.s	saimoveinimigo	; Sai da Rotina

movedireita2
	move.w	inimfase,d0
	cmp.w	inifase,d0		; A Fase é igual ao Número Máximo de Fases?
	beq.s	incmoveinimigo	; Se sim Incrementa a Posição
	addq.w	#4,inirx		; Se não Incrementa a Posição Horizontal Real do Inimigo
	addq.w	#1,inifase		; Incrementa a Fase
	bra.s	saimoveinimigo	; Sai da Rotina
	
incmoveinimigo
	move.w	initx,d0
	add.w	d0,inix			; Incrementa a Posição de Acordo com o Tamanho do Inimigo
	move.w	#0,inifase		; Muda a Fase Para Zero

saimoveinimigo

	rts
	
; Movimenta a Nave
movenave

	clr.w	d0

	move.b	joy+1,d0		; Verifica o Joystick 1

	cmp		#128,d0			; O botão de Disparo foi pressionado?
	blt.s	no_fire			; Se não então passa à frente
	
	tst.w	tiro			; Se sim então verifica se existe o Tiro?
	beq.w	criatiro		; Se não então Cria o Tiro

	and.b	#%01111111,d0	; Limpa o bit do botão de Disparo
	
no_fire

	cmp.b	#4,d0			; Move a Nave para a Esquerda
	beq.s	naveleft
	
	cmp.b	#8,d0			; Move a Nave para a Direira
	beq.s	naveright

	bra.w	saimovenave		; Sai da Rotina

; 	Move a Nave para a Esquerda
naveleft
	tst.w 	nx				; A Posição da Nave é Zero?
	beq.s	vnfasezero		; Se sim Verifica se a Fase é Zero
	
	tst.w	nfase			; A Fase é Zero?
	beq.s	decmovenave		; Se sim Decrementa a Posição
	subq.w	#4,nrx			; Se não Decrementa a Posição Horizontal Real da Nave
	subq.w	#1,nfase		; Decrementa a Fase
	bra.w	saimovenave		; Sai da Rotina
	
vnfasezero
	tst.w	nfase			; A Fase é Zero?
	beq.w	saimovenave		; Se sim Sai da Rotina
	subq.w	#4,nrx			; Se não Decrementa a Posição Horizontal Real da Nave	
	subq.w	#1,nfase		; Decrementa a Fase
	bra.s	saimovenave		; Sai da Rotina
	
decmovenave
	move.w	ntx,d0			; Decrementa a Posição de Acordo com o Tamanho da Nave
	sub.w	d0,nx
	move.w	nmfase,nfase	; Muda a Fase Para o Número Máximo de Fases (-1)
	bra.s	saimovenave		; Sai da Rotina
	
; Move a Nave para a Direira
naveright
	move.w	#320-16,d0
	sub.w	ntx,d0
	cmp.w	nx,d0			; A Posição da Nave é Igual a 320 menos o Tamanho da Nave?
	beq.s	vnfasemax		; Se sim Verifica se a Fase é a Máxima

	move.w	nmfase,d0		
	cmp.w	nfase,d0		; A Fase é igual ao Número Máximo de Fases (-1)?
	beq.s	incmovenave		; Se sim Incrementa a Posição
	addq.w	#4,nrx			; Se não Incrementa a Principal Horizontal Real da Nave
	addq.w	#1,nfase		; Incrementa o Número da Fase
	bra.s	saimovenave		; Sai da Rotina
	
vnfasemax
	move.w	nmfase,d0		
	cmp.w	nfase,d0		; Verifica se a Fase é igual ao Número Máximo de Fases (-1)?
	beq.s	saimovenave		; Se sim Sai da Rotina
	addq.w	#4,nrx			; Se não Incrementa a Principal Horizontal Real da Nave
	addq.w	#1,nfase		; Incrementa o Número da Fase
	bra.s	saimovenave		; Sai da Rotina
	
incmovenave
	move.w	ntx,d0			; Incrementa a Posição de Acordo com o Tamanho da Nave
	add.w	d0,nx
	move.w	#0,nfase		; Muda a Fase Para Zero

saimovenave

	rts

; Cria o Tiro
criatiro

	move.w	nx,tix			; Posição Horizontal do Tiro
	move.w	nrx,tirx		; Posição Horizontal Real do Tiro
	move.w	ny,d0
	sub.w	tity,d0
	move.w	d0,tiy			; Posição Vertical do Tiro
	move.w	nfase,tifase	; Fase do Tiro
	
	move.w	#1,tiro			; Ativa o Tiro
	
	rts

; Movimenta o Tiro
movetiro

; 	Move o Tiro para Cima
	tst.w 	tiy			; A Posição do Tiro é Zero?
	bne.s	decmovetiro	; Se não Decrementa a Posição do Tiro
	
	move.w	#0,tiro		; Se Sim desativa o Tiro
	bra.s	saimovetiro	; Sai da Rotina
	
decmovetiro
	subq.w	#4,tiy		; Decrementa o Tiro
	
saimovetiro

	rts

; Verifica a Colisão entro o Tiro e o Inimigo
vercolisao1

	move.w	tiy,d0
	add.w	tity,d0
	cmp.w	iniy,d0
	blt.s	saivercolisao1
	
	move.w	iniy,d0
	add.w	inity,d0
	cmp.w	tiy,d0
	blt.s	saivercolisao1
	
	move.w	tirx,d0
	add.w	tirtx,d0
	cmp.w	inirx,d0
	blt.s	saivercolisao1
	
	move.w	inirx,d0
	add.w	initx,d0
	cmp.w	tirx,d0
	ble.s	saivercolisao1
	
;	move.w	tifase,d0
;	cmp.w	inifase,d0
;	bne.w	saivercolisao1

	bsr.s	somexplosao		; Cria o Som da Explosão
	bsr.s	criaexplosao	; Cria a Explosão
	move.w	#00,tiro		; Desativa o Tiro
	jsr		getrandom		; Cria uma nova Posição Horizontal para o Inimigo

saivercolisao1

	rts
	
; Cria uma Explosão
criaexplosao

	move.w	inix,exx		; Posição Horizontal da Explosão
	move.w	inirx,exrx		; Posição Horizontal Real da Explosão
	move.w	iniy,exy		; Posição Vertical da Explosão
	move.w	inifase,exfase	; Fase da Explosão
	
	move.w	#1,explo		; Ativa a Explosão

	rts

; "Move" a Explosão
moveexplosao

	sub.w	#1,excnt		; Decrementa o Tempo da Explosão
	tst.w	excnt			; É igual a Zero?
	bgt.s	saimoveexplosao	; Se não Sai da Rotina
	
	move.w #20,excnt		; Se sim Repõe o Tempo da Explosão
	move.w #0,explo			; Desativa a Explosão

saimoveexplosao

	rts
	
; Cria o Som de uma Explosão
somexplosao	
	
	move.b	#7,$ff8800
	move.b	#1,$ff8802

	move.b	#6,$ff8800
	move.b	#31,$ff8802

	move.b	#8,$ff8800
	move.b	#16,$ff8802
	
	move.b	#9,$ff8800
	move.b	#0,$ff8802
	
	move.b	#10,$ff8800
	move.b	#0,$ff8802

	move.b	#11,$ff8800
	move.b	#184,$ff8802
	
	move.b	#12,$ff8800
	move.b	#11,$ff8802
	
	move.b	#13,$ff8800
	move.b	#9,$ff8802
	
	rts
	
	
section data

pic1 incbin sprites.pi1

old_stack		dc.l	0
old_resolution	dc.w	0
old_screen		dc.l	0
old_vbl			dc.l	0

new_screen		dc.l	0

; Nave
ntx				dc.w	16	; Tamanho Horizontal da Nave
nty				dc.w	16	; Tamanho Vertical da Nave
nrtx			dc.w	16	; Tamanho Horizontal Real da Nave
nx				dc.w	160	; Posição Horizontal da Nave
ny				dc.w	184	; Posição Vertical da Nave
nrx				dc.w	160 ; Posição Horizontal Real da Nave
nfase			dc.w	0	; Fase da Nave
nmfase			dc.w	3	; Número Máximo de Fases da Nave (-1)
npx				dc.w	0	; Posição Horizontal da Nave na Imagem que contém os Sprites
npy				dc.w	32	; Posição Vertical da Nave na Imagem que contém os Sprites

; Tiro
tiro			dc.w	0	; Existe Tiro?
titx			dc.w	16	; Tamanho Horizontal do Tiro
tity			dc.w	8	; Tamanho Vertical do Tiro
tirtx			dc.w	10	; Tamanho Horizontal Real do Tiro
tix				dc.w	0	; Posição Horizontal do Tiro
tiy				dc.w	0	; Posição Vertical do Tiro
tirx			dc.w	0 	; Posição Horizontal Real do Tiro
tifase			dc.w	0	; Fase do Tiro
timfase			dc.w	3	; Número Máximo de Fases do Tiro (-1)
tipx			dc.w	0	; Posição Horizontal do Tiro na Imagem que contém os Sprites
tipy			dc.w	64	; Posição Vertical do Tiro na Imagem que contém os Sprites

; Inimigo
initx			dc.w	16	; Tamanho Horizontal da Inimigo
inity			dc.w	16	; Tamanho Vertical da Inimigo
inirtx			dc.w	16	; Tamanho Horizontal Real da Inimigo
inix			dc.w	160	; Posição Horizontal da Inimigo
iniy			dc.w	0	; Posição Vertical da Inimigo
inirx			dc.w	160 ; Posição Horizontal Real do Inimigo
inifase			dc.w	0	; Fase da Inimigo
inimfase		dc.w	3	; Número Máximo de Fases do Inimigo (-1)
inipx			dc.w	0	; Posição Horizontal da Inimigo na Imagem que contém os Sprites
inipy			dc.w	0	; Posição Vertical da Inimigo na Imagem que contém os Sprites
inidx			dc.w	0	; Direção do Movimento Horizontal do Inimigo (Esquerda ou Direita)

; Explosão
explo			dc.w	0	; Existe Explosão?
excnt			dc.w	20	; Tempo que a Explosão permanece no Écran
extx			dc.w	16	; Tamanho Horizontal da Explosão
exty			dc.w	16	; Tamanho Vertical do Explosão
exrtx			dc.w	16	; Tamanho Horizontal Real da Explosão
exx				dc.w	0	; Posição Horizontal do Explosão
exy				dc.w	0	; Posição Vertical da Explosão
exrx			dc.w	0 	; Posição Horizontal Real da Explosão
exfase			dc.w	0	; Fase da Explosão
exmfase			dc.w	3	; Número Máximo de Fases da Explosão (-1)
expx			dc.w	0	; Posição Horizontal da Explosão na Imagem que contém os Sprites
expy			dc.w	48	; Posição Vertical da Explosão na Imagem que contém os Sprites

prsproff		dc.l	0	; Offset do Écran a ser Impresso o Sprite
sproff			dc.l	0	; Offset do Sprite na Imagem que contém os Sprites

sprtx			dc.w	0	; Tamanho Horizontal do Sprite
sprty			dc.w	0	; Tamanho Vertical do Sprite

sprx			dc.w	0	; Posição Horizontal onde o Sprite vai ser Impresso
spry			dc.w	0	; Posição Vertical onde o Sprite vai ser Impresso

osprx			dc.w	0	; Posição Horizontal onde está o Sprite na Imagem que contém os Sprites
ospry			dc.w	0	; Posição Vertical onde está o Sprite na Imagem que contém os Sprites

numlw			dc.w	0	; Número de LongWords do Sprite a serem copiadas
numlw2			dc.l	0	; Número de Bytes a serem Saltados para a linha seguinte

joy_on			dc.b	$14	; Joystick
mus_on			dc.b	$08	; Rato
ikbd_vec		dc.l	0
old_joy			dc.l	0


section bss

screen_buf		ds.b	32256
old_palette		ds.l	8

joy				ds.b	2